## debputy 0.1.28

=== Makefile ===
#!/usr/bin/make -f

DEBPUTY_INSTALLED_ROOT_DIR=/usr/share/dh-debputy
DEBPUTY_INSTALLED_PLUGIN_ROOT_DIR=/usr/share/debputy/

# Nothing to do by default
all:

check:
	py.test -v

install:
	install -m0755 -d \
	    $(DESTDIR)/usr/bin \
	    $(DESTDIR)/$(DEBPUTY_INSTALLED_ROOT_DIR) \
	    $(DESTDIR)/$(DEBPUTY_INSTALLED_PLUGIN_ROOT_DIR)/debputy \
	    $(DESTDIR)/usr/share/perl5/Debian/Debhelper/Sequence \
	    $(DESTDIR)/usr/share/man/man1
	install -m0755 -t $(DESTDIR)/usr/bin dh_debputy dh_installdebputy assets/debputy
	install -m0755 -t $(DESTDIR)/$(DEBPUTY_INSTALLED_ROOT_DIR) deb_packer.py deb_materialization.py
	install -m0644 -t $(DESTDIR)/usr/share/perl5/Debian/Debhelper/Sequence lib/Debian/Debhelper/Sequence/*.pm
	cp -a --reflink=auto src/debputy $(DESTDIR)/$(DEBPUTY_INSTALLED_ROOT_DIR)
	cp -a --reflink=auto debputy $(DESTDIR)/$(DEBPUTY_INSTALLED_PLUGIN_ROOT_DIR)
	sed -i "s/^__version__ =.*/__version__ = '$$(dpkg-parsechangelog -SVersion)'/; s/^__release_commit__ =.*/__release_commit__ = 'N\\/A'/;" \
	   $(DESTDIR)/$(DEBPUTY_INSTALLED_ROOT_DIR)/debputy/version.py
	perl -p -i -e 's{^DEBPUTY_ROOT_DIR =.*}{DEBPUTY_ROOT_DIR = pathlib.Path("$(DEBPUTY_INSTALLED_ROOT_DIR)")};' \
	   $(DESTDIR)/$(DEBPUTY_INSTALLED_ROOT_DIR)/debputy/__init__.py
	perl -p -i -e 's{^DEBPUTY_PLUGIN_ROOT_DIR =.*}{DEBPUTY_PLUGIN_ROOT_DIR = pathlib.Path("$(DEBPUTY_INSTALLED_PLUGIN_ROOT_DIR)")};' \
	   $(DESTDIR)/$(DEBPUTY_INSTALLED_ROOT_DIR)/debputy/__init__.py
	find $(DESTDIR)/usr/share/dh-debputy -type d -name '__pycache__' -exec rm -fr {} +
	pod2man --utf8 --section=1 --name="debputy" -c "The debputy Debian packager helper stack" debputy.pod \
	   $(DESTDIR)/usr/share/man/man1/debputy.1
	pod2man --utf8 --section=1 --name="dh_debputy" -c "The debputy Debian packager helper stack" dh_debputy \
	   $(DESTDIR)/usr/share/man/man1/dh_debputy.1
	pod2man --utf8 --section=1 --name="dh_installdebputy" -c "The debputy Debian packager helper stack" dh_installdebputy \
	   $(DESTDIR)/usr/share/man/man1/dh_installdebputy.1
	chmod -R u=rwX,go=rX \
	    $(DESTDIR)/$(DEBPUTY_INSTALLED_ROOT_DIR)/debputy \
	    $(DESTDIR)/$(DEBPUTY_INSTALLED_PLUGIN_ROOT_DIR)/debputy

=== debian/changelog ===
debputy (0.1.28) unstable; urgency=medium

  [ Niels Thykier ]
  * LSP/Lint:
    - Fix missing `binary-targets` value for R³
    - Emit multiple issues for the same value if applicable in deb822 files
    - Detect exclusive values used with other values in deb822 files. Examples
      include `any` or `all` in the `Architecture` field.
    - Add `hover` docs to `debian/copyright` fields.
    - Add basic support for cross-file data reference. As an example,
      the `debputy.manifest` code can now determine which packages are
      listed in `debian/control`. Additionally, the `debian/changelog` checks
      will now assert that the source package name in the newest entry match
      the `Source` field of `debian/control`.
    - Provide specialized hover docs for `debian/control` that provides
      specialized help for the synopsis part of the `Description` field.
    - The hover docs for `debian/control` will now provide hover docs for
      some substvars.

  * debputy: `lsp features` now reports if general features are missing
  * d/copyright: Add missing `GPL-2+` and missing `Apache-2` license stanzas

  [ Andrea Pappacoda ]
  * `debputy lsp editor-configs`: Add `yegappan`'s VIM LSP.
    (https://github.com/yegappan/lsp).

 -- Niels Thykier <niels@thykier.net>  Wed, 10 Apr 2024 13:32:34 +0000

debputy (0.1.27.1) unstable; urgency=medium

  [ David Kalnischkies ]
  * Improve LSP hover docs:
    - Don't encode <> in Uploaders field description
    - Use consistently markdown */** instead of <em>/<b>
    - Use markdown <automatic links> for URIs in text
    - Define all allowed priorities only once
    - Use **Example**: consistently in descriptions
    - Format text consistently with `file` and `path/`

  [ Niels Thykier ]
  * LSP/Lint: Fix typo in `Upstream-Contact` field.
    Thanks to gregor herrmann <gregoa@debian.org> (Closes: #1068523)

 -- Niels Thykier <niels@thykier.net>  Sun, 07 Apr 2024 08:18:06 +0200

debputy (0.1.27) unstable; urgency=medium

  * LSP/Lint:
    - Disable automatic syntax check of makefiles (`debian/rules`)
      by default. The `make` man page strongly implies that it "may"
      run code, which will be unhelpful to anyone using `debputy lint`
      to review packages.
    - The `debputy.manfiest` diagnostics now flag conflicting
      attributes in the manifest. Previously, these were only flagged
      by `debputy check-manifest` or during build.  (Closes: #85)
    - When there is a typo of a keyword in `debputy.manifest` with one
      obvious solution, the linting will continue linting based on
      the corrected key rather than the original key.
    - Improve the `debputy.manifest` diagnostics to cover deeper into
      the manifest. Among other, it now offers some validation of
      `ManifestCondition` (`when:`).

  [ Niels Thyker ]
  * Add `python3-levenshtein` to Suggests.

  [ David Kalnischkies ]
  * Fix a number of typos and other spelling related issues.
  * Reformat files to remove trailing whitespace

 -- Niels Thykier <niels@thykier.net>  Sat, 06 Apr 2024 12:23:44 +0200

debputy (0.1.26) unstable; urgency=medium

  * LSP/lint:
    - Make debputy.manifest completer better at accounting for conflicting
      keywords such as `as` vs. `sources` in `install`.
    - The debputy.manifest completer now provides completions in more cases.
    - Add basic support `debian/tests/control`. Note that `elpa-dpkg-dev-el`
      does not support it yet in unstable (in git, expected to be 37.22) and
      `vim` does not seem  to have support for it.

  * migrate-from-dh:
    - Provide migration advice for known hook targets. Additionally, hook
      targets with migration advice no longer triggers an unsupported
      feature error (only a manual migration warning).
      (Closes: debputy#78)

  * lint: Fix crash bug when auto-fixing something at the start of a file

 -- Niels Thykier <niels@thykier.net>  Thu, 04 Apr 2024 12:36:11 +0200

debputy (0.1.25) unstable; urgency=medium

  * LSP/lint:
    - Provide initial hover docs for `d/debputy.manifest`.
    - Provide initial completion support for `d/debputy.manifest`.
    - Provide more diagnostics for `d/debputy.manifest`. Note that
      `debputy check-manifest` still covers a lot more, but it usually
      only reports one issue at the time and does not work with the LSP.
    - When the editor does not provide a language id for the files,
      `debputy` now attempts to guess the language from the filename.
      This makes the language server work with most editors that do
      not know about the file format (such as `debian/debputy.manifest`).

  [ Niels Thykier ]
  * d/copyright: Dual license linter and LSP, since that makes it easier
    to share code with `debpkg-metadata`.
  * debputy: Add YAML mode (debputy.manifest) to emacs LSP editor config
    example.
  * LSP/lint: Fix crash bug with some errors in debputy.manifest
  * Migrate to `python3-ruyaml` as default. It has fewer arch:any
    dependencies, which in turn should make arch bootstrapping easier.
    (Closes: debputy#84)
  * debputy: Make `debputy lsp editor-config` list known config names.
    Thanks to David Kalnischkies <david@kalnischkies.de> (Closes: debputy#82)
  * LSP: Fallback to filename based detection if no language id is provided

  [ Otto Kekäläinen ]
  * Add Lintian overrides
  * Add Salsa-CI to both build packages, and to run `debputy lint` on itself

 -- Niels Thykier <niels@thykier.net>  Thu, 04 Apr 2024 07:18:03 +0200

debputy (0.1.24) unstable; urgency=medium

  * Manifest:
    - Add new keyword `services` under `packages.foo`, where the
      packager can specify whether a given service or (systemd) unit
      should be enabled/started on installation and how upgrades
      should be managed. With this, more packages using
      `dh_installsystemd` and `dh_installinit` can hopefully now use
      `debputy`. Note user services is mentioned in the manifest
      feature, but `debputy` does not actually detect any user


=== debian/control ===
Source: debputy
Section: devel
Priority: optional
Maintainer: Debputy Maintainers <debputy@packages.debian.org>
Uploaders: Niels Thykier <niels@thykier.net>,
Build-Depends: debhelper-compat (= 13),
#               man-db <pkg.debputy.ci>,
               dh-sequence-single-binary,
               hunspell-en-us <!nocheck>,
               python3-colored <!pkg.debputy.minimal>,
               python3-colorlog <!pkg.debputy.minimal>,
               python3-debian,
               python3-hunspell <!nocheck>,
               python3-levenshtein <pkg.debputy.ci>,
               python3-lsprotocol <!nocheck>,
               python3-pygls <!nocheck !pkg.debputy.minimal-tests>,
               python3-pytest <!nocheck>,
               python3-pytest-cov <pkg.debputy.test-coverage>,
               python3-ruyaml,
#               debputy-plugin-foo,
# The code was never checked with an older version than 3.11...
               python3:any (>= 3.11~),
               strip-nondeterminism <!nocheck>,
Rules-Requires-Root: no
Standards-Version: 4.6.2
Homepage: https://salsa.debian.org/debian/debputy
Vcs-Git: https://salsa.debian.org/debian/debputy.git
Vcs-Browser: https://salsa.debian.org/debian/debputy

Package: dh-debputy
Architecture: all
Depends: debhelper,
         man-db <!pkg.debputy.minimal>,
# The colors dependencies are not necessary for debputy to work.
# However, to have coloring work, we need to use Depends because
# Recommends/Suggests are not resolved for builds and this should
# "just work" for users.
         python3-colored <!pkg.debputy.no-color>,
         python3-colorlog <!pkg.debputy.no-color>,
         python3-debian,
         python3-ruyaml,
# The code was never checked with an older version than 3.11...
         python3:any (>= 3.11~),
         strip-nondeterminism,
Recommends: python3-argcomplete,
Suggests: hunspell-en-us,
          python3-hunspell,
          python3-levenshtein,
          python3-lsprotocol,
          python3-pygls,
Provides: debputy-plugin-gnome,
          debputy-plugin-numpy3,
          debputy-plugin-perl-openssl,
          dh-sequence-debputy (= ${binary:Version}),
          dh-sequence-installdebputy (= ${binary:Version}),
          dh-sequence-zz-debputy (= ${binary:Version}),
          dh-sequence-zz-debputy-rrr (= ${binary:Version}),
Multi-Arch: foreign
Description: Manifest style Debian-based package builder (debhelper integration)
 Package builder that provides a declarative manifest for building Debian-based
 packages.
 .
 This version integrates with the debhelper sequencer dh and will replace
 several of debhelper's tools that are covered by debputy.
 .
 The debputy package builder aims to reduce cognitive load for the packager
 and provide better introspection to packagers, linters and the Debian
 janitor.

=== debian/rules ===
#!/usr/bin/make -f

export PERL5LIB=$(CURDIR)/lib
export PATH:=$(CURDIR):$(PATH)
export DEBPUTY_CMD=$(CURDIR)/debputy.sh

%:
	dh $@ --with debputy

override_dh_debputy:
	dh_debputy --plugin self-hosting-plugins/debputy-self-hosting.json

=== debian/tests/control ===
Tests: debputy-py.test
Restrictions: allow-stderr
# debputy loads the libcap2 library directly for one of the tests
Depends: libcap2,
         python3-all,
         python3-lsprotocol,
         python3-pytest,
         @,

Tests: debputy-cli
Restrictions: allow-stderr, superficial
Depends: @,

Tests: debputy-cli-lint-lsp
Restrictions: allow-stderr, superficial
Depends: python3-lsprotocol,
         @,

Tests: debputy-cli-lsp
Restrictions: allow-stderr, superficial
Depends: python3-lsprotocol,
         python3-pygls,
         @,

## debputy 0.1.34

=== debian/changelog ===
debputy (0.1.34) unstable; urgency=medium

  * LSP/Lint:
    - Improve Synopsis hover docs by using a wording closer to
      DevRef 6.2.2 and provide a reference example for comparison.
    - Detect some issues with the Synopsis of package description.
      Example include detecting known placeholders, the synopsis being
      too short (single word), and the synopsis starting with an
      article.
    - Avoid emitting diagnostic for missing `Standards-Version` when
      the source package only produces `udebs`.
    - Limit diagnostics of `debian/changelog` to the first two issues
      (Closes: debputy#92)
    - The `black` style no longer normalizes stanza order. Instead,
      current order is preserved as-is.
    - Fix negated architectures being considered a typo. This is a quick
      fix that side-steps the issue. However, the current solution should
      be replaced by a specialized diagnostic logic for `Architecture`.
      Thanks to
      Picca Frédéric-Emmanuel <frederic-emmanuel.picca@synchrotron-soleil.fr>
      for reporting the issue.

  * debputy: Support `junit` report format for the `lint` subcommand.
    (Closes: debputy#99)
  * d/control: Have `dh-debputy` provide `debputy` for now to simplify
    installation. The documentation still uses `dh-debputy` until such
    a time where it makes sense to create a standalone `debputy` package.
  * Improve support for `dwz` being missing to match `debhelper`

 -- Niels Thykier <niels@thykier.net>  Tue, 21 May 2024 14:48:10 +0000

debputy (0.1.33) unstable; urgency=medium

  * LSP/Lint:
    - Check `Files` in debian/copyright for unnecessary syntactical segments.
    - Add basic validation of `Standards-Version` field (like out of date
      Standards-Version or incorrect format)
    - Add support for `debian/patches/series`. Note that for the LSP support
      you will probably need `--ignore-language-ids` for it to activate.
      Current features are:
      + Semantic tokens: Comments + Patches (as "String") are matched.
        Some patch options are marked too.
      + Diagnostics: Patches not mentioned, non-existent patches, duplicate
        patches, patches not ending with .diff/.patch (to aid editor
        support), and syntax issues.
      + Completion: Patch names are completed. Option completion is not
        supported (but `debian/patches/series` only allows `-p1` which
        is redundant).
    - Packages with multiple `Vcs-*` fields (ignoring `Vcs-Browser`) now
      triggers a diagnostic.
    - Linter (but not LSP) now has a separate severity for spelling issues
      called `spelling`. It works like the previous severity for all intents
      and purposes, it is just a different name for the same severity.

  * d/control: Bump Standards-Version to 4.7.0 - no changes required
  * Add basic `grantlee` packaging plugin to match the `debhelper`
    sequence add-on of same name.

 -- Niels Thykier <niels@thykier.net>  Thu, 09 May 2024 10:43:23 +0000

debputy (0.1.32) unstable; urgency=medium

  * LSP/Lint:
    - Fix bug where `d/copyright` and `d/tests/control` was read as `d/control`
      in `debputy lsp server` (`debputy lint` was unaffected).
    - Fix bug in `in_range` detection that was sometimes completely off. This
      could cause incorrect hover docs or completion suggestions to appear.
      Admittedly, the above bug almost makes this one seem like a non-issue
      in comparison.
    - Support completing filenames in `Files` fields of `debian/copyright`.
  * debputy reformat: Provide separate message for no style vs. unsupported
    style

 -- Niels Thykier <niels@thykier.net>  Sun, 05 May 2024 12:41:27 +0000

debputy (0.1.31) unstable; urgency=medium

  * LSP/Lint:
    - Read `wrap-and-sort` args from `salsa-ci` as fallback
    - Prune more fields and values in the deb822 completer based on
      the context. As an example, `same` is no longer suggested as
      a completion for `Multi-Arch` if the package is
      `Architecture: all`. (Closes: debputy#88)
    - Flag `X-Time64-Compat` as an issue in `Architecture: all`
      packages.
    - Update hover doc for `M-A: allowed` to clarify how rare it is
      (less than 0.5%, down to 0.05% for `Architecture: all`).

  [ Niels Thykier ]
  * d/control: Allow `python3-ruamel.yaml` as alternative
  * CI: Add CI tests to validate Ubuntu/noble works
  * debputy reformat: Add option to not error out on missing styles

  [ Maytham Alsudany ]
  * LSP: Update Section reference data to include `golang` and `httpd`.

 -- Niels Thykier <niels@thykier.net>  Sat, 04 May 2024 11:18:18 +0000

debputy (0.1.30) unstable; urgency=medium

  * LSP/Lint:
    - Detect duplicate separators (commas) in most fields
    - Fix typo in hover doc for `DM-Upload-Allowed`
    - Support `X-Style: black` as style declaration to activate
      automatic reformatting support. Conceptually, this is similar
      to `wrap-and-sort -satkb` but it may evolve over time.
    - Support reformatting of field contents on save or via explicit
      reformat document request from editor (requires that `debputy`
      knows which style you want - see previous entry for how to do
      a per-package rule).
    - Update `emacs+eglot` editor config snippet after the latest
      elpa-dpkg-dev-el upload.

  * Fix crash bug in embedded python3-debian code
  * Declare styles for:
    - Niels Thykier (black)
    - Chris Hofstaedtler (black)

  * style-prefs.yaml: Adding format rules for several packages
  * Apply `debian black` style to `d/tests/control`
  * Fix duplicate stderr logger with LSP (and similar commands)
  * Fix invalid assertion error in some packages (Closes: #1069362)
  * Cope better with `python3-colored (<< 2)`
    Thanks to Chris Hofstaedtler <zeha@debian.org>
  * Provide a new reformat subcommand. It works like `debputy lint`, but
    only does formatting (which `debputy lint` does none of).
  * debputy lint: Fix crash bug on missing `Source` field in `d/control`


=== debian/control ===
Source: debputy
Section: devel
Priority: optional
Maintainer: Debputy Maintainers <debputy@packages.debian.org>
Uploaders:
 Niels Thykier <niels@thykier.net>,
Build-Depends:
 debhelper-compat (= 13),
#               man-db <pkg.debputy.ci>,
 dh-sequence-single-binary,
 hunspell-en-us <!nocheck>,
 python3-colored <!pkg.debputy.minimal>,
 python3-colorlog <!pkg.debputy.minimal>,
 python3-debian,
 python3-hunspell <!nocheck>,
 python3-levenshtein <pkg.debputy.ci>,
 python3-lsprotocol <!nocheck>,
 python3-pygls <!nocheck !pkg.debputy.minimal-tests>,
 python3-pytest <!nocheck>,
 python3-pytest-cov <pkg.debputy.test-coverage>,
 python3-ruyaml | python3-ruamel.yaml,
#               debputy-plugin-foo,
# The code was never checked with an older version than 3.11...
 python3:any (>= 3.11~),
 strip-nondeterminism <!nocheck>,
Rules-Requires-Root: no
X-Style: black
Standards-Version: 4.7.0
Homepage: https://salsa.debian.org/debian/debputy
Vcs-Git: https://salsa.debian.org/debian/debputy.git
Vcs-Browser: https://salsa.debian.org/debian/debputy

Package: dh-debputy
Architecture: all
Depends:
 debhelper,
 dwz <!pkg.debputy.minimal>,
 man-db <!pkg.debputy.minimal>,
# The colors dependencies are not necessary for debputy to work.
# However, to have coloring work, we need to use Depends because
# Recommends/Suggests are not resolved for builds and this should
# "just work" for users.
 python3-colored <!pkg.debputy.no-color>,
 python3-colorlog <!pkg.debputy.no-color>,
 python3-debian,
 python3-ruyaml | python3-ruamel.yaml,
# The code was never checked with an older version than 3.11...
 python3:any (>= 3.11~),
 strip-nondeterminism,
Recommends:
 python3-argcomplete,
Suggests:
 hunspell-en-us,
 python3-hunspell,
 python3-junit.xml,
 python3-levenshtein,
 python3-lsprotocol,
 python3-pygls,
Provides:
 debputy (= ${binary:Version}),
 debputy-plugin-gnome,
 debputy-plugin-grantlee,
 debputy-plugin-numpy3,
 debputy-plugin-perl-openssl,
 dh-sequence-debputy (= ${binary:Version}),
 dh-sequence-installdebputy (= ${binary:Version}),
 dh-sequence-zz-debputy (= ${binary:Version}),
 dh-sequence-zz-debputy-rrr (= ${binary:Version}),
Multi-Arch: foreign
Description: Manifest style Debian-based package builder (debhelper integration)
 Package builder that provides a declarative manifest for building Debian-based
 packages.
 .
 This version integrates with the debhelper sequencer dh and will replace
 several of debhelper's tools that are covered by debputy.
 .
 The debputy package builder aims to reduce cognitive load for the packager
 and provide better introspection to packagers, linters and the Debian
 janitor.

## debputy 0.1.35

=== debian/changelog ===
debputy (0.1.35) unstable; urgency=medium

  [ Niels Thykier ]
  * Manifest:
    - Fix inverted boolean logic causing `path-metadata` to reject matched
      directories when it should have allowed the match.

  * LSP/Lint:
    - In regex based validation, ignore values with substvars to avoid
      false positives.
    - Fix typo in hover doc
    - Fix two minor bugs (an out of bounds and None exception)
    - Avoid double colon when completion YAML keys and there was already
      a colon.
    - Fix a bug where the YAML completion would not work properly if there was
      any content on the line after the current line.


  * debputy: Considerably reduce the output during package build by:
    - Do not announce loading of bundled plugins
    - Avoid unnecessary output related to installations (like search dir and
      discard rules) for `rrr` integration mode.
    - Reduce the log level to `warning` by default from info (other subcommands
      still start on `info` level by default). In the `debhelper` integration
      modes, `export DH_VERBOSE=1` will restore the `info` level logging.
    - Guard some information (such as most commands being run) beyond info
      logging.

  [ Colin Watson ]
  * LSP/Lint: Fix section for python3-zope.*

 -- Niels Thykier <niels@thykier.net>  Wed, 05 Jun 2024 17:33:57 +0000

## debputy 0.1.36~bpo12+1

=== debian/changelog ===
debputy (0.1.36~bpo12+1) bookworm-backports; urgency=medium

  * Rebuild for bookworm-backports as requested by the `lighttpd`
    maintainers in the following MR:
    https://salsa.debian.org/debian/lighttpd/-/merge_requests/47
  * Remove two optional build-dependencies that cannot be satisfied
    in -backports currently.
  * Tweak some code to fix a benign CI breakage for the unstable job
    when the build-dependencies were removed. (The main branch now
    has a CI job for this case to avoid future irrelevant breakage)
  * Disable (remove) some autopkgtests that cannot be run in
    bookworm-backports due to missing dependencies.

 -- Niels Thykier <niels@thykier.net>  Thu, 13 Jun 2024 08:51:23 +0000

debputy (0.1.36) unstable; urgency=medium

  * LSP/Lint: Basic detection of hook targets that will not be run
    with `debputy` sequences (debputy#103). Known issues are:
      - The check does not account for sequences loaded via
        `debian/rules`.
      - The diagnostics does not automatically refresh in the
        language server when changing `debian/control`. The work
        around is to do a minor change to `debian/rules` to
        re-trigger it.
  * Internal refactoring of linter and LSP to make it easier to
    make some build-dependencies fully optional, which in turn
    makes backporting `debputy` to bookworm-backports a lot easier.
  * debian/control: Mark some build-dependencies unnecessary for
    bookworm-backports via a package specific build profile.

 -- Niels Thykier <niels@thykier.net>  Sun, 09 Jun 2024 11:45:02 +0000

=== debian/control ===
--- 
+++ 
@@ -14,8 +14,6 @@
  python3-debian,
  python3-hunspell <!nocheck>,
  python3-levenshtein <pkg.debputy.ci>,
- python3-lsprotocol <!nocheck>,
- python3-pygls <!nocheck !pkg.debputy.minimal-tests>,
  python3-pytest <!nocheck>,
  python3-pytest-cov <pkg.debputy.test-coverage>,
  python3-ruyaml | python3-ruamel.yaml,

=== debian/tests/control ===
Tests:
 debputy-py.test,
Restrictions:
 allow-stderr,
# debputy loads the libcap2 library directly for one of the tests
Depends:
 libcap2,
 python3-all,
 python3-pytest,
 @,

Tests:
 debputy-cli,
Restrictions:
 allow-stderr,
 superficial,
Depends:
 @,

## debputy 0.1.37

=== debian/changelog ===
debputy (0.1.37) unstable; urgency=medium

  * LSP/Lint:
    - Provide `sort text` for some completion suggestions to have
      editors promote or demote certain values. Example being `allowed`,
      which is rarely used and is now demoted below other options.
    - Provide synopsis docs for various completion suggestions related
      to field values.
    - Provide a diagnostic for a "directory-only" match used in a
      `Files` field of `debian/copyright'.
    - Provide a diagnostic for `debhelper` config files and PPFs that
      uses a name segment without an explicit package prefix. These
      are possible typos of a real package name and additionally, they
      are deprecated in debhelper compat 14 (removal planned for compat
      15). Note that `debputy` did not allow name segments without
      explicit package prefix for the PPFs it supported, so this
      should only affect `debhelper` packages.
    - Provide a diagnostic for 'debhelper` config files and PPFs that
      used by commands not active in the `dh` sequence given the
      current set of add-ons. This only applies to packages using
      `dh` and relies 100% on `dh_assistant` providing useful data
      for the package in question. For this feature to work,
      `debhelper (>= 13.16~)` is needed. With older versions of
      `debhelper` the check is silently disabled.
    - Detect some typos in the "stem" part of debhelper config files
      and PPFs (both `debputy` and `debhelper` provided PPFs).
      Due to a technical limitation, the check only works when
      there is exactly one match for the stem within
      "typo edit distance". This means that typos of some stems
      are likely to be unreported. A trivial example is the
      typo `debian/dcos`, which is equally close to `debian/docs` and
      `debian/dirs`.


  * Update salsa CI configuration to better support backports
  * Fix bug in handling absence of `python3-lsprotocol` in unstable
  * Add missing help descriptions to `lint` and `reformat`
  * Add a `debian/clean` to remove files after "rules-less" experiments
  * debputy: `debputy lsp features` now reports if a newer version of
    `debhelper` would help or provide improve support. Currently, the
    lowest bound for passing is now `debhelper (>= 13.16~)`. The bound
    may be bumped in the future as the need arises.

 -- Niels Thykier <niels@thykier.net>  Mon, 17 Jun 2024 16:07:04 +0000

## debputy 0.1.39~bpo12+1

=== debian/changelog ===
debputy (0.1.39~bpo12+1) bookworm-backports; urgency=medium

  * Rebuild for bookworm-backports.
  * Remaining delta compared to testing:
    - Remove two optional build-dependencies that cannot be satisfied
      in -backports currently.
    - Disable (remove) some autopkgtests that cannot be run in
      bookworm-backports due to missing dependencies.

 -- Niels Thykier <niels@thykier.net>  Wed, 26 Jun 2024 16:14:39 +0000

debputy (0.1.39) unstable; urgency=medium

  * LSP/Lint:
    - Reference wiki.d.o/PackageTransition for `Breaks`, `Conflicts` and
      `Replaces` hover docs.
    - Fix false-positive "unused `symbols` file". Thanks to
      Otto Kekäläinen <otto@debian.org> (Closes: debputy#107)

  * debputy: `lsp features` now works even without minimum requires installed

 -- Niels Thykier <niels@thykier.net>  Mon, 24 Jun 2024 07:52:09 +0000

debputy (0.1.38) unstable; urgency=medium

  * LSP/Lint:
    - Avoid self-DOS when checking packaging file names
    - Perform more checks of packaging files
    - Ignore `fundamental` language ID (from `emacs`'s `fundamental-mode`)
  * debputy: Explicitly state how to see the editor snippets in the list of
    snippets
  * debputy: Special-case the file-level range in the output in the
    `junit4-xml` output format for `debputy lint`.
  * Fix matching of packager provided files for some corner cases. As a
    side-effect, some more corner cases of typos of the name stem are
    now detected by the LSP/Lint and annotate-debian-directory code
    when `python3-levenshtein` is installed. As an example,
    `foo.uxxr.service` can now be reported as a typo of `user.service`
    (for `dh_installsystemduser`) where it was previously considered a
    `service` file with a name segment of `uxxr` (for `dh_installsystemd`).
    Though, this only happens subcommands that active look for typos
    (such as the LSP/Lint part) and only when `python3-levenshtein` is
    enabled (check `debputy lsp features` for the `typo detection`).

 -- Niels Thykier <niels@thykier.net>  Thu, 20 Jun 2024 05:54:24 +0000

debputy (0.1.37~bpo12+1) bookworm-backports; urgency=medium

  * Rebuild for bookworm-backports.
  * Fixed delta compared to testing:
    - Tweak some code to fix a benign CI breakage for the unstable job
      when the build-dependencies were removed. (The main branch now
      has a CI job for this case to avoid future irrelevant breakage)
  * Remaining delta compared to testing:
    - Remove two optional build-dependencies that cannot be satisfied
      in -backports currently.
    - Disable (remove) some autopkgtests that cannot be run in
      bookworm-backports due to missing dependencies.

 -- Niels Thykier <niels@thykier.net>  Thu, 20 Jun 2024 06:14:26 +0000

=== debian/control ===
--- 
+++ 
@@ -46,6 +46,7 @@
  python3:any (>= 3.11~),
  strip-nondeterminism,
 Recommends:
+ debhelper (>= 13.16~),
  python3-argcomplete,
 Suggests:
  hunspell-en-us,

## debputy 0.1.42

=== debian/changelog ===
debputy (0.1.42) unstable; urgency=medium

  * LSP/Lint:
    - Fix exception on some syntax errors
    - Add `X?-Ruby-Versions` as a known (obsolete) field
    - Include the final line of context (`debputy lint`-only)
    - Syntax check dependency relation fields
    - Detect incorrect version operators in `Provides`
    - Fix crash on package stanzas without `Package` field
    - Flag usage of `|` in relationship fields that does not
      support it
    - Fix invalid ranges for some checks when using field comments

 -- Niels Thykier <niels@thykier.net>  Sat, 06 Jul 2024 18:50:17 +0000

debputy (0.1.41) unstable; urgency=medium

  * LSP/Lint:
    - Fix typo in diagnostic message
    - Reduce the number of false positive pkgfile typo warnings.
      Thanks to Otto Kekäläinen <otto@debian.org> (Closes: debputy#109)
    - Avoid recommending name segment for packaging files that do not
      support that.  Note all `debhelper` files currently "support"
      name segments as far as `debputy` can tell, since `dh_assistant`
      does not track this feature.
  * debputy reformat: Fix error in instructions
  * debputy-documentation.json: Add `debian/lintian-brush.conf` as
    known file.

 -- Niels Thykier <niels@thykier.net>  Tue, 02 Jul 2024 20:52:51 +0000

debputy (0.1.40) unstable; urgency=medium

  * Manifest changes:
    - The manifest parser now validates the used features against the
      integration mode. This causes some invalid manifests to be
      detected at parse time (`debputy manifest`) rather than at
      build time for `dh-sequence-zz-debputy-rrr`).

  * LSP/Lint:
    - Use `dh_assistant` to determine inactive commands. This improves
      the check to cover commands that `debhelper` knows are inactive.
      However, the functionality now requires `debhelper (>= 13.15~)`.
    - Apply sequences from `debian/control` when analyzing `debian/rules`.
      Note for LSP: Depending on your editor, you may have to save
      `debian/control` first and then trigger a change in `debian/rules`
      for it to be visible. (Known issue, see debputy#103 and debputy#108)
    - Provide inlay hints for inherited fields in `debian/control`.
    - Provide integration mode level checks for most features. The
      capabilities on `path-metadata` is a known and notable case where
      the LSP/Lint side is silent where `debputy check-manifest` would
      complain.
    - Provide a warning for unknown capabilities (that `cap_from_text`
      does not recognize). Previously, this would only appear in
      `debputy check-manifest` or during builds.
    - Validate boolean and enum-like values for attributes of the
      manifest. These would previously only be caught by
      `debputy check-manifest` or during builds.

  * debputy: Remove internal `--integration-mode=rrr` option.
  * dh_debputy: Remove internal `--integration-mode=rrr` option.

 -- Niels Thykier <niels@thykier.net>  Sun, 30 Jun 2024 12:43:55 +0000

## debputy 0.1.43

=== debian/changelog ===
debputy (0.1.43) unstable; urgency=medium

  * debputy: Only warn about missing `-dev` SO symlinks for libraries
    in common lib paths (such as usr/lib/${MA})
  * debputy: Fix bug where `DH_VERBOSE` would fail to print all
    commands
  * debputy: Distinguish between `--debug` and `DH_VERBOSE` in terms
    of verbosity.
  * debputy: Restore `Multi-Arch: same` field in dbgsym packages.
    Thanks to Russ Allbery <rra@debian.org>

 -- Niels Thykier <niels@thykier.net>  Sun, 07 Jul 2024 07:18:46 +0000

## debputy 0.1.45

=== debian/changelog ===
debputy (0.1.45) unstable; urgency=medium

  * Manifest:
    - Add new `default-build-environment`, `build-environments` and `build-rules`
      for the new `full` integration mode where `debhelper` is no longer driving
      the build.
    - Port all `debhelper` provided build systems to have an native `debputy`
      counter part with a few tweaks.


  * LSP/Lint:
    - Add `xpm` as a known extension for packager files
    - Add `Build-Driver` as a known field for `debian/control`.
    - Add `Files-Excluded` and `Files-Included` as known fields for DEP-5
    - Quote values in completation items for the manifest. This means that
      the value for `manifest-version` is now properly YAML quoted.

  * debputy: Remove `--spellcheck` from "random" subcommands
  * debputy: Fix missing warning with `--debug` (it was supposed to be omitted,
    but never was due to exception flow).
  * debputy reformat: Fix bug where orphaned packages would have a style by default
  * doc: Document decision on plugin module import vs. initialization design
  * LSP/Lint: Fix crash with certain field being duplicated
  * MANIFEST-FORMAT.md: Fix wording
  * Add initial minimal `Build-Driver` support meaning that `debputy` can now use
    `dpkg-buildpackage`'s new `Build-Driver` support to drive the build without
    relying on `dh`. This requires bleeding edge features in `dpkg-buildpackage`
    and `debputy`.
  * Avoid stacktrace for CTRL + C during `run_command`
  * Improve error tracking related to plugins
  * Add remark about `env:` manifest variables sometimes respecting
    `build-environment`.

 -- Niels Thykier <niels@thykier.net>  Sun, 04 Aug 2024 12:37:21 +0000

debputy (0.1.44) unstable; urgency=medium

  * LSP:
    - Provide hover docs for packages in relationship fields. Due to
      implementation limitations, OR relations (`foo | bar`) do not
      work. The hover doc relies on the system's APT cache with all
      the limitations from that (like the data not matching the target
      distribution)
    - Fix wording in the synopsis hover doc

  * debputy reformat: If possible provide the reformatting tool when the
    style cannot be applied.
  * debputy: Remove `printf` debug when log level is changed
  * debputy: Prefer using line numbers in error messages when available
  * editor-config: Improve the LSP config for `eglot`
  * debputy: Improve mode correction for `*.pm` files.
    Thanks to Russ Allbery <rra@debian.org> (Closes: #1076346)

 -- Niels Thykier <niels@thykier.net>  Mon, 15 Jul 2024 11:24:40 +0000

=== debian/control ===
--- 
+++ 
@@ -14,6 +14,8 @@
  python3-debian,
  python3-hunspell <!nocheck>,
  python3-levenshtein <pkg.debputy.ci>,
+ python3-lsprotocol <!nocheck !pkg.debputy.bookworm-backports>,
+ python3-pygls <!nocheck !pkg.debputy.minimal-tests !pkg.debputy.bookworm-backports>,
  python3-pytest <!nocheck>,
  python3-pytest-cov <pkg.debputy.test-coverage>,
  python3-ruyaml | python3-ruamel.yaml,

## debputy 0.1.46~bpo12+1

=== debian/changelog ===
debputy (0.1.46~bpo12+1) bookworm-backports; urgency=medium

  * Rebuild for bookworm-backports.

 -- Niels Thykier <niels@thykier.net>  Tue, 13 Aug 2024 12:57:25 +0000

debputy (0.1.46) unstable; urgency=medium

  * LSP:
    - Improve wording of and fix typo in hover docs.
    - Fix a typo of `hyphen-` that would distrupt "name to section"
      checks for `hyphen-` packages.

  [ Niels Thykier ]
  * LSP: Fix typo of `hyphen-` and improve wording `Multi-Arch` field
  * debputy: Hoist `nocheck` and `nodoc` into `DEB_BUILD_OPTIONS`
    Thanks to Chris Hofstaedtler <zeha@debian.org>
  * Skip `debian/foo.1` for packager provided files typo checks.
    Thanks to Chris Hofstaedtler <zeha@debian.org>
  * Set `PKG_CONFIG` ENV var for  `perl-makemaker`
  * Fix bug in initialization of `EnvironmentModification` (only affects
    packages in `full` integration mode).
  * Fix bug in escape_util and have it use more readable output by default
  * Fix bug where pre-compressed manpage would be corrupted.
    Thanks to Andrey Rakhmatullin <wrar@debian.org> (Closes: #1078448)

  [ Guillem Jover ]
  * LSP: Fix typos in several descriptions


 -- Niels Thykier <niels@thykier.net>  Sat, 10 Aug 2024 18:16:23 +0000

## debputy 0.1.47~bpo12+1

=== debian/changelog ===
debputy (0.1.47~bpo12+1) bookworm-backports; urgency=medium

  * Rebuild for bookworm-backports.
  * Remaining delta compared to testing:
    - Remove two optional build-dependencies that cannot be satisfied
      in -backports currently.
    - Disable (remove) some autopkgtests that cannot be run in
      bookworm-backports due to missing dependencies.

 -- Niels Thykier <niels@thykier.net>  Thu, 15 Aug 2024 04:57:50 +0000

debputy (0.1.47) unstable; urgency=medium

  * LSP/Lint:
    - Fix missing textwrap.dedent for hover docs
    - Tweak wording for undocumented fields
    - Tweak wording for the `important` value from `Priority`
    - Tweak rendering of header of hover docs for known value
    - In hover docs, recognize `debputy-plugin-X` similar to `dh-sequence-Y`
    - Make a d/changelog diagnostic message a bit more precise

  * migrate-from-dh:
    - Add remark about https://bugs.debian.org/1067653 in relevant
      warnings.

  * Expand documentation on integration modes (Closes: debputy#117)
  * debputy: Fix a warning from auto-detecting when the source
    package has no `debhelper` compat level.
  * debputy: Restore log output from `pygls` (`debputy lsp server`)


 -- Niels Thykier <niels@thykier.net>  Tue, 13 Aug 2024 12:44:52 +0000

=== debian/control ===
--- 
+++ 
@@ -14,8 +14,6 @@
  python3-debian,
  python3-hunspell <!nocheck>,
  python3-levenshtein <pkg.debputy.ci>,
- python3-lsprotocol <!nocheck !pkg.debputy.bookworm-backports>,
- python3-pygls <!nocheck !pkg.debputy.minimal-tests !pkg.debputy.bookworm-backports>,
  python3-pytest <!nocheck>,
  python3-pytest-cov <pkg.debputy.test-coverage>,
  python3-ruyaml | python3-ruamel.yaml,
@@ -72,9 +70,15 @@
  Package builder that provides a declarative manifest for building Debian-based
  packages.
  .
- This version integrates with the debhelper sequencer dh and will replace
- several of debhelper's tools that are covered by debputy.
- .
  The debputy package builder aims to reduce cognitive load for the packager
  and provide better introspection to packagers, linters and the Debian
  janitor.
+ .
+ This version integrates with the debhelper sequencer dh. Multiple integration
+ modes are possible with dh. The most trivial integration mode is
+ dh-sequence-zz-debputy-rrr, which is a mostly standard dh sequence with very
+ few changes aimed entirely at removing the need for fakeroot when assmebling
+ the .deb.
+ .
+ For more information on all integration modes and what they do, please see
+ https://salsa.debian.org/debian/debputy/-/blob/main/INTEGRATION-MODES.md

## debputy 0.1.48~bpo12+1

=== debian/changelog ===
debputy (0.1.48~bpo12+1) bookworm-backports; urgency=medium

  * Rebuild for bookworm-backports.
  * Remaining delta compared to testing:
    - Remove two optional build-dependencies that cannot be satisfied
      in -backports currently.
    - Disable (remove) some autopkgtests that cannot be run in
      bookworm-backports due to missing dependencies.

 -- Niels Thykier <niels@thykier.net>  Tue, 20 Aug 2024 08:46:57 +0000

debputy (0.1.48) unstable; urgency=medium

  * INTEGRATION-MODES.md: Correct `bullseye` that should have been `bookworm`
  * Also set PKG_CONFIG in the `perl-build` build system like with
    is done in the `perl-makemaker` build system.
  * Remove lintian-overrides since `debputy` no longer uses `dh`
  * d/control: Fix typo in description
  * debputy.pod: Document security aspects of `debputy lsp server`
    and `debputy lint`.
  * debputy: Fix inaccurate directory listing in an error message.
  * debputy: Ensure `u+rwX` as min mode when installing paths into the
    packages. This change prevent crashes when upstream has marked
    paths as read-only (such as `0444`).
    Thanks to Andrey Rakhmatullin <wrar@debian.org> (Closes: #1078906)
    Note: Paths can still get their user write bit removed via
    transformations or built-in rules (such as files in `etc/sudoers.d`
    which must be `0440`)
  * debputy: Require directory mode to always have `u+rwx`. Previously,
    only the `u+rx` mode was required. There is no known use-case for
    directories to not have a read, write and execute for the owner.

 -- Niels Thykier <niels@thykier.net>  Sun, 18 Aug 2024 09:47:40 +0000

=== debian/control ===
--- 
+++ 
@@ -77,7 +77,7 @@
  This version integrates with the debhelper sequencer dh. Multiple integration
  modes are possible with dh. The most trivial integration mode is
  dh-sequence-zz-debputy-rrr, which is a mostly standard dh sequence with very
- few changes aimed entirely at removing the need for fakeroot when assmebling
+ few changes aimed entirely at removing the need for fakeroot when assembling
  the .deb.
  .
  For more information on all integration modes and what they do, please see

## debputy 0.1.48

=== Makefile ===
--- 
+++ 
@@ -15,10 +15,12 @@
 	    $(DESTDIR)/$(DEBPUTY_INSTALLED_ROOT_DIR) \
 	    $(DESTDIR)/$(DEBPUTY_INSTALLED_PLUGIN_ROOT_DIR)/debputy \
 	    $(DESTDIR)/usr/share/perl5/Debian/Debhelper/Sequence \
+	    $(DESTDIR)/usr/share/perl5/Dpkg/BuildDriver \
 	    $(DESTDIR)/usr/share/man/man1
 	install -m0755 -t $(DESTDIR)/usr/bin dh_debputy dh_installdebputy assets/debputy
 	install -m0755 -t $(DESTDIR)/$(DEBPUTY_INSTALLED_ROOT_DIR) deb_packer.py deb_materialization.py
 	install -m0644 -t $(DESTDIR)/usr/share/perl5/Debian/Debhelper/Sequence lib/Debian/Debhelper/Sequence/*.pm
+	install -m0644 -t $(DESTDIR)/usr/share/perl5/Dpkg/BuildDriver lib/Dpkg/BuildDriver/*.pm
 	cp -a --reflink=auto src/debputy $(DESTDIR)/$(DEBPUTY_INSTALLED_ROOT_DIR)
 	cp -a --reflink=auto debputy $(DESTDIR)/$(DEBPUTY_INSTALLED_PLUGIN_ROOT_DIR)
 	sed -i "s/^__version__ =.*/__version__ = '$$(dpkg-parsechangelog -SVersion)'/; s/^__release_commit__ =.*/__release_commit__ = 'N\\/A'/;" \

=== debian/control ===
--- 
+++ 
@@ -14,6 +14,8 @@
  python3-debian,
  python3-hunspell <!nocheck>,
  python3-levenshtein <pkg.debputy.ci>,
+ python3-lsprotocol <!nocheck !pkg.debputy.bookworm-backports>,
+ python3-pygls <!nocheck !pkg.debputy.minimal-tests !pkg.debputy.bookworm-backports>,
  python3-pytest <!nocheck>,
  python3-pytest-cov <pkg.debputy.test-coverage>,
  python3-ruyaml | python3-ruamel.yaml,

## debputy 0.1.50

=== debian/changelog ===
debputy (0.1.50) unstable; urgency=medium

  * LSP:
    - Tweaked many of the hover doc and completion docs
      for Deb822 files.
    - Avoid false positive "typo of `.wm`" for vim's hidden
      `.swp` files.
      Thanks to David Kalnischkies <david@kalnischkies.de>
      for reporting the issue.  (Closes: debputy#121)
    - Initial support for `debian/upstream/metadata`. Top-level
      keys are now known, have hover docs and can be completed.
      Unknown keys are accepted without warning provided they
      are not considered a typo of a known field.

  * migrate-from-dh:
    - Support migrating from `dh_shell_completions`.

  * Fix synopsis for `DM-Upload-Allowed` field
  * Refactored the hover doc and known field logic for Deb822 based
    files and extracted most of it into separate data files.
  * debputy lsp server: Handle multiple initializations
    more gracefully. This is mostly relevant for debugging
    via the `--tcp` option.
  * Add support zsh/fish-completion files as known packaging files
    that `debputy` can install. Note that `debputy` uses `completion`
    rather than `completions` (compared to `dh_shell_completions`).
    The `debputy migrate-from-dh` will spot and fix the difference.
  * d/control: Add `debputy-lsp` to Suggests

 -- Niels Thykier <niels@thykier.net>  Sat, 14 Sep 2024 10:09:04 +0000

debputy (0.1.49) unstable; urgency=medium

  * LSP/Lint:
    - Tweak hover docs and add synopsis for a lot of fields
    - Add missing dependency validation for `Pre-Depends`
    - Check for missing files like `debian/copyright`. For
      the LSP style, it is reported for the `Source` field
      of the `d/control` file.
    - Add two trivial checks for extended description
    - Ensure `debhelper` is at least 13.19~ to avoid
      false-positive diagnostic (Closes: debputy#120)

  * Move some LSP reference data to a separate data file
  * Support translation of fields and many values. No translations
    done yet.

 -- Niels Thykier <niels@thykier.net>  Sat, 31 Aug 2024 13:20:00 +0000
